import javax.swing.*;
import java.awt.event.*;

/**
 * Pannello che permette di sostituire un carattere con un altro in un testo
 * Versione con JRadioButton
 *
 */

public class Grafica2PanelButton extends JPanel implements ActionListener{
	
	private JTextField t1, t4;
	private JRadioButton[] rbOld;
	private JRadioButton[] rbNew;
	private JButton b;
	
	public Grafica2PanelButton()
	{
		t1 = new JTextField(25);
		t4 = new JTextField(25);
		t4.setEditable(false);
		this.add(t1);
		this.add(new JLabel("Vecchio carattere"));
		rbOld = new JRadioButton[26];
		ButtonGroup groupOld = new ButtonGroup();
		for (int i = (int)'a'; i <= (int)'z'; i++)
		{
			rbOld[i-(int)'a'] = new JRadioButton(""+(char)i);
			groupOld.add(rbOld[i-(int)'a']);
			this.add(rbOld[i-(int)'a']);
		}
		this.add(new JLabel("Nuovo carattere"));
		rbNew = new JRadioButton[26];
		ButtonGroup groupNew = new ButtonGroup();
		for (int i = (int)'a'; i <= (int)'z'; i++)
		{
			rbNew[i-(int)'a'] = new JRadioButton(""+(char)i);
			groupNew.add(rbNew[i-(int)'a']);
			this.add(rbNew[i-(int)'a']);
		}
		b = new JButton("Sostituisci");
		b.addActionListener(this); //in questo modo ho detto che e' il pannello stesso che rimane in ascolto per l'evento scatenato dal bottone
		this.add(t4);
		this.add(b);
	}

	public void actionPerformed(ActionEvent e)
	{
		// usiamo uno StringBuffer per poter modificare i singoli caratteri
		StringBuffer sb = new StringBuffer(t1.getText());
		char oldC, newC;
		oldC = 'a';
		newC = 'a';
		// valuta quale carattere vecchio e' stato scelto
		for (int i = (int)'a'; i <= (int)'z'; i++)
			if (rbOld[i-(int)'a'].isSelected())
			{
				oldC = (char)i;
				break;
			}
		// valuta quale carattere nuovo e' stato scelto
		for (int i = (int)'a'; i <= (int)'z'; i++)
			if (rbNew[i-(int)'a'].isSelected())
			{
				newC = (char)i;
				break;
			}
		// ricerca il vecchio carattere nel testo
		for(int i = 0; i<sb.length(); i++)
		{
			// se lo trova, lo sostituisce con il nuovo
			if(sb.charAt(i)== oldC)
				sb.setCharAt(i, newC);
		}
		t4.setText(sb.toString());
	}
}
