import javax.swing.*;
import java.awt.event.*;

/**
 * Pannello che permette di sostituire un carattere con un altro in un testo
 * Versione con JComboBox
 *
 */

public class Grafica2PanelCombo extends JPanel implements ActionListener{
	
	private JTextField t1, t4;
	private JComboBox cbOld;
	private JComboBox cbNew;
	private JButton b;
	
	public Grafica2PanelCombo()
	{
		t1 = new JTextField(25);
		t4 = new JTextField(25);
		t4.setEditable(false);
		this.add(t1);
		this.add(new JLabel("Vecchio carattere"));
		cbOld = new JComboBox();
		for (int i = (int)'a'; i <= (int)'z'; i++)
		{
			cbOld.addItem(""+(char)i);
		}
		this.add(cbOld);
		this.add(new JLabel("Nuovo carattere"));
		cbNew = new JComboBox();
		for (int i = (int)'a'; i <= (int)'z'; i++)
		{
			cbNew.addItem(""+(char)i);
		}
		this.add(cbNew);
		b = new JButton("Sostituisci");
		b.addActionListener(this); //in questo modo ho detto che e' il pannello stesso che rimane in ascolto per l'evento scatenato dal bottone
		this.add(t4);
		this.add(b);
	}

	public void actionPerformed(ActionEvent e)
	{
		// usiamo uno StringBuffer per poter modificare i singoli caratteri
		StringBuffer sb = new StringBuffer(t1.getText());
		char oldC, newC;
		oldC = 'a';
		newC = 'a';
		// valuta quale carattere vecchio e' stato scelto
		// recuperando la stringa scelta e selezionando il primo carattere
		oldC = ((String)cbOld.getSelectedItem()).charAt(0);
		// valuta quale carattere nuovo e' stato scelto
		// recuperando la stringa scelta e selezionando il primo carattere
		newC = ((String)cbNew.getSelectedItem()).charAt(0);
		// ricerca il vecchio carattere nel testo
		for(int i = 0; i<sb.length(); i++)
		{
			// se lo trova, lo sostituisce con il nuovo
			if(sb.charAt(i)== oldC)
				sb.setCharAt(i, newC);
		}
		t4.setText(sb.toString());
	}
}
